=== debian/changelog ===
getdp (2.9.2+dfsg1-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * [04e3ffc] Update build-depends package names.

 -- Anton Gladky <gladk@debian.org>  Thu, 01 Sep 2016 23:06:23 +0200

getdp (2.9.2+dfsg1-1) unstable; urgency=medium

  * [4f026fb] Update d/watch.
  * [0409196] Refresh patch.
  * [e6e3939] Update d/copyright.
  * [747a881] Update d/rules.
  * [06aef20] Apply cme fix dpkg.
  * [cf50fad] Add myself to uploaders.
  * [59e3934] Imported Upstream version 2.9.2+dfsg1

 -- Anton Gladky <gladk@debian.org>  Mon, 22 Aug 2016 21:03:33 +0200

getdp (2.7.0-4) unstable; urgency=medium

  * Team upload.
  * Switch from swig2.0 to swig. (Closes: #823929)

 -- Graham Inggs <ginggs@debian.org>  Tue, 10 May 2016 21:13:22 +0200

getdp (2.7.0-3) unstable; urgency=medium

  * Team upload.
  * No change rebuild to gain dependencies on the newer libpetsc and libslepc
    package names.

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 21 Apr 2016 12:40:52 +0000
