## getdp 2.11.3+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
+# GetDP - Copyright (C) 1997-2017 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@onelab.info>.
@@ -38,6 +38,7 @@
 opt(FORTRAN "Enable Fortran (needed for Arpack/Sparskit/Zitsol & Bessel)" ${DEFAULT})
 opt(GMSH "Enable Gmsh functions (for field interpolation)" ${DEFAULT})
 opt(GSL "Enable GSL functions (for some built-in functions)" ${DEFAULT})
+opt(HPDDM "Enable HPDDM support" ${DEFAULT})
 opt(KERNEL "Enable kernel (required for actual computations)" ON)
 opt(MPI "Enable MPI parallelization (with PETSc/SLEPc)" OFF)
 opt(MULTIHARMONIC "Enable multi-harmonic support" OFF)
@@ -50,6 +51,7 @@
 opt(SLEPC "Enable SLEPc eigensolver" ${DEFAULT})
 opt(SMALLFEM "Enable experimental SmallFem assembler" OFF)
 opt(SPARSKIT "Enable Sparskit solver instead of PETSc (requires Fortran)" ${DEFAULT})
+opt(PEWE "Enable PeWe exact solutions (requires Fortran)" ${DEFAULT})
 opt(WRAP_PYTHON "Build Python wrappers" OFF)
 opt(ZITSOL "Enable Zitsol solvers (requires PETSc and Fortran)" OFF)
 
@@ -60,8 +62,8 @@
 endif(ENABLE_FORTRAN)
 
 set(GETDP_MAJOR_VERSION 2)
-set(GETDP_MINOR_VERSION 9)
-set(GETDP_PATCH_VERSION 2)
+set(GETDP_MINOR_VERSION 11)
+set(GETDP_PATCH_VERSION 3)
 set(GETDP_EXTRA_VERSION "" CACHE STRING "GetDP extra version string")
 
 set(GETDP_VERSION "${GETDP_MAJOR_VERSION}.${GETDP_MINOR_VERSION}")
@@ -74,8 +76,12 @@
   Kernel/GetDP.h
 )
 
-execute_process(COMMAND date "+%Y%m%d" OUTPUT_VARIABLE DATE
-                OUTPUT_STRIP_TRAILING_WHITESPACE)
+if(${CMAKE_MAJOR_VERSION} GREATER 2)
+  string(TIMESTAMP DATE "%Y%m%d")
+else(${CMAKE_MAJOR_VERSION} GREATER 2)
+  execute_process(COMMAND date "+%Y%m%d" OUTPUT_VARIABLE DATE
+                  OUTPUT_STRIP_TRAILING_WHITESPACE)
+endif(${CMAKE_MAJOR_VERSION} GREATER 2)
 execute_process(COMMAND hostname OUTPUT_VARIABLE HOSTNAME
                 OUTPUT_STRIP_TRAILING_WHITESPACE)
 execute_process(COMMAND whoami OUTPUT_VARIABLE PACKAGER
@@ -86,11 +92,13 @@
 endif(NOT DATE)
 set(GETDP_DATE "${DATE}")
 
-if(NOT HOSTNAME)
-  set(HOSTNAME "unknown")
-endif(NOT HOSTNAME)
-set(GETDP_HOST "${HOSTNAME}")
-
+if(NOT GETDP_HOST)
+  if(NOT HOSTNAME)
+    set(HOSTNAME "unknown")
+  endif(NOT HOSTNAME)
+  set(GETDP_HOST "${HOSTNAME}")
+endif(NOT GETDP_HOST)
+    
 if(NOT PACKAGER)
   set(PACKAGER "unknown")
 endif(NOT PACKAGER)
@@ -100,6 +108,7 @@
   set(GETDP_OS "MacOSX")
 elseif(CYGWIN)
   set(GETDP_OS "Windows")
+  add_definitions(-DWIN32) # recent mingw compiler doesn't define it
 else(APPLE)
   set(GETDP_OS "${CMAKE_SYSTEM_NAME}")
 endif(APPLE)
@@ -108,6 +117,29 @@
 include(CheckFunctionExists)
 include(CheckIncludeFile)
 include(CheckCXXCompilerFlag)
+
+macro(set_config_option VARNAME STRING)
+  set(${VARNAME} TRUE)
+  list(APPEND CONFIG_OPTIONS ${STRING})
+  message(STATUS "Found " ${STRING})
+endmacro(set_config_option)
+
+# check if the machine is 64 bits (this is more reliable than using
+# CMAKE_SIZEOF_VOID_P, which does not seem to work e.g. on some Suse
+# machines)
+check_type_size("void*" SIZEOF_VOID_P)
+if(SIZEOF_VOID_P EQUAL 8)
+  set_config_option(HAVE_64BIT_SIZE_T "64Bit")
+endif(SIZEOF_VOID_P EQUAL 8)
+
+# append 32/64 to the build name on Linux and Windows
+if(NOT APPLE)
+  if(HAVE_64BIT_SIZE_T)
+    set(GETDP_OS "${GETDP_OS}64")
+  else(HAVE_64BIT_SIZE_T)
+    set(GETDP_OS "${GETDP_OS}32")
+  endif(HAVE_64BIT_SIZE_T)
+endif(NOT APPLE)
 
 if(ENABLE_WRAP_PYTHON AND NOT ENABLE_BUILD_SHARED)
   set(ENABLE_BUILD_DYNAMIC ON)
@@ -130,8 +162,10 @@
 if(ENABLE_OPENMP)
   find_package(OpenMP)
   if(OPENMP_FOUND)
+    set_config_option(HAVE_OPENMP "OpenMP")
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
+    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${OpenMP_Fortran_FLAGS}")
   endif(OPENMP_FOUND)
 endif(ENABLE_OPENMP)
 
@@ -163,19 +197,16 @@
   endif(NUM_FOUND_LIBRARIES LESS NUM_LIST)
 endmacro(find_all_libraries)
 
-macro(set_config_option VARNAME STRING)
-  set(${VARNAME} TRUE)
-  list(APPEND CONFIG_OPTIONS ${STRING})
-  message(STATUS "Found " ${STRING})
-endmacro(set_config_option)
-
-# check if the machine is 64 bits (this is more reliable than using
-# CMAKE_SIZEOF_VOID_P, which does not seem to work e.g. on some Suse
-# machines)
-check_type_size("void*" SIZEOF_VOID_P)
-if(SIZEOF_VOID_P EQUAL 8)
-  set_config_option(HAVE_64BIT_SIZE_T "64Bit")
-endif(SIZEOF_VOID_P EQUAL 8)
+macro(set_compile_flags LISTNAME FLAGS)
+  foreach(FILE ${${LISTNAME}})
+    get_source_file_property(PROP ${FILE} COMPILE_FLAGS)
+    if(PROP)
+      set_source_files_properties(${FILE} PROPERTIES COMPILE_FLAGS "${PROP} ${FLAGS}")
+    else(PROP)
+      set_source_files_properties(${FILE} PROPERTIES COMPILE_FLAGS "${FLAGS}")
+    endif(PROP)
+  endforeach(FILE)
+endmacro(set_compile_flags)
 
 if(ENABLE_BLAS_LAPACK)
   if(BLAS_LAPACK_LIBRARIES)
@@ -265,37 +296,3 @@
       set(OPENBLAS_LIBS_REQUIRED openblas)
       find_all_libraries(LAPACK_LIBRARIES OPENBLAS_LIBS_REQUIRED "" "")
       if(LAPACK_LIBRARIES)
-        set_config_option(HAVE_BLAS "Blas(OpenBlas)")
-        set_config_option(HAVE_LAPACK "Lapack(OpenBlas)")
-        find_library(GFORTRAN_LIB gfortran)
-        if(GFORTRAN_LIB)
-          list(APPEND LAPACK_LIBRARIES ${GFORTRAN_LIB})
-        endif(GFORTRAN_LIB)
-      endif(LAPACK_LIBRARIES)  
-    endif(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
-
-    if(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
-      # if we still haven't found blas and lapack, use the standard cmake tests,
-      # which require a working Fortran compiler
-      enable_language(Fortran)
-      find_package(BLAS)
-      if(BLAS_FOUND)
-        set_config_option(HAVE_BLAS "Blas")
-        find_package(LAPACK)
-        if(LAPACK_FOUND)
-          set_config_option(HAVE_LAPACK "Lapack")
-        else(LAPACK_FOUND)
-          set(LAPACK_LIBRARIES ${BLAS_LIBRARIES})
-        endif(LAPACK_FOUND)
-      endif(BLAS_FOUND)
-    endif(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
-  endif(BLAS_LAPACK_LIBRARIES)
-endif(ENABLE_BLAS_LAPACK)
-
-add_subdirectory(Common)
-add_subdirectory(Interface)
-add_subdirectory(Numeric)
-
-if(ENABLE_KERNEL)
-  add_subdirectory(Kernel)
-  set_config_option(HAVE_KERNEL "Kernel")
