=== Kernel/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
+# GetDP - Copyright (C) 1997-2017 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@onelab.info>.
@@ -9,6 +9,7 @@
       F_Geometry.cpp F_Interpolation.cpp F_Hysteresis.cpp F_Math.cpp
       F_Misc.cpp F_MultiHar.cpp F_Raytracing.cpp
       F_Gmsh.cpp F_DiffGeom.cpp F_Octave.cpp F_Python.cpp
+      F_PeWe.cpp
     BF_Node.cpp BF_NodeXYZ.cpp BF_Node_2.cpp BF_Node_3.cpp
       BF_Edge.cpp BF_Edge_2.cpp BF_Edge_3.cpp BF_Edge_4.cpp
       BF_Facet.cpp BF_Volume.cpp BF_Region.cpp
@@ -32,9 +33,10 @@
       Operation_IterativeLoopN.cpp
       Operation_IterativeLinearSolver.cpp
       Operation_IterativeTimeReduction.cpp
-      Operation_Update.cpp
+      Operation_Update.cpp Operation_Vector.cpp
       Operation_ChangeOfCoordinates.cpp
-	  Operation_PostOperation.cpp
+      Operation_PostOperation.cpp
+      Operation_HPDDM.cpp Operation_Debug.cpp
       Treatment_Formulation.cpp
         Get_DofOfElement.cpp
         Get_ConstraintOfElement.cpp
@@ -45,6 +47,7 @@
         Pre_TermOfFemEquation.cpp
           Generate_Network.cpp
         Cal_GalerkinTermOfFemEquation.cpp
+        Cal_SmallFemTermOfFemEquation.cpp
         Cal_GlobalTermOfFemEquation.cpp
           Cal_IntegralQuantity.cpp
           Cal_AnalyticIntegration.cpp
