=== Numeric/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
+# GetDP - Copyright (C) 1997-2017 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@onelab.info>.
