=== debian/changelog ===
getdp (2.11.3+dfsg1-2build1) cosmic; urgency=medium

  * No-change rebuild against petsc 3.9

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 10 Aug 2018 17:27:08 +0000

getdp (2.11.3+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Debian patch link_fortran.patch: Ensure gfortran is always linked.
    Linking gfortran to LAPACK gave variable results: it didn't get
    added when built against ATLAS.
  * Apply upstream patches 5f171b22 and 8610fc15 to enable build
    against PETSc 3.9. Closes: #898325.
  * Don't build an rpath into binaries (activate CMAKE_SKIP_RPATH)
  * Standards-Version: 4.1.5

 -- Drew Parsons <dparsons@debian.org>  Mon, 09 Jul 2018 00:18:57 +0800

getdp (2.11.3+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * [d38e28c] New upstream version 2.11.3+dfsg1
  * [b40b549] Refresh patch
  * [c750307] Set compat-level 11
  * [4dd8d7b] Update VCS-field
  * [bc96935], [d73e945] Update d/copyright
  * [8765624] Remove banner to prevent privacy-breach
  * [e76dcd0] Update d/copyright
  * [1fe9192] Remove banner to prevent privacy-breach
  * [39ab84a] Remove myself from uploaders
  * [f1fd2b3] Set Standards-version 4.1.3
  * [096aad7] Update patch

 -- Anton Gladky <gladk@debian.org>  Wed, 28 Feb 2018 23:20:54 +0100
