=== debian/control ===
--- 
+++ 
@@ -1,24 +1,23 @@
 Source: getdp
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>,
-           Anton Gladky <gladk@debian.org> 
+Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>
 Section: math
-Priority: extra
+Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 9),
+               debhelper (>= 11),
                gfortran,
                libarpack2-dev,
-               libgsl0-dev,
+               libgsl-dev,
                mpi-default-dev,
                petsc-dev,
                python-dev,
-               libslepc3.4.2-dev,
+               slepc-dev,
                swig,
                texlive,
                texlive-generic-recommended
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/getdp.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/getdp.git
+Standards-Version: 4.1.5
+Vcs-Browser: https://salsa.debian.org/science-team/getdp
+Vcs-Git: https://salsa.debian.org/science-team/getdp.git
 Homepage: http://www.geuz.org/getdp
 
 Package: getdp
