=== debian/rules ===
--- 
+++ 
@@ -11,11 +11,11 @@
 export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure --builddirectory=$(BUILDDIR_PETSC) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=1 -DENABLE_SPARSKIT=0
-	dh_auto_configure --builddirectory=$(BUILDDIR_SPARSKIT) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=0 -DENABLE_SPARSKIT=1
+	dh_auto_configure --builddirectory=$(BUILDDIR_PETSC) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=1 -DENABLE_SPARSKIT=0 -DCMAKE_SKIP_RPATH:BOOL=ON
+	dh_auto_configure --builddirectory=$(BUILDDIR_SPARSKIT) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=0 -DENABLE_SPARSKIT=1 -DCMAKE_SKIP_RPATH:BOOL=ON
 	sed -i 's/-lpthread/-lgfortran -lpthread/' debian/build/*/CMakeFiles/getdp.dir/link.txt
